#include "ThreadedWorker.h"
#include <osg/Notify>


ThreadedWorker::ThreadedWorker()
 : _done(false)
{
	OSG_ALWAYS<<"ThreadedWorker instantiated."<<std::endl;
}

ThreadedWorker::~ThreadedWorker()
{
	cancel();
}

void ThreadedWorker::run()
{
	OSG_ALWAYS<<"ID "<<getThreadId()<<" running!"<<std::endl;

	// Do the work
	int i=0;
	do
	{
		OSG_ALWAYS<<"ID "<<getThreadId()<<" :: itr "<<i++<<std::endl;

		// Place Holder
		for(int i=0;i<100;i++)
		OSG_ALWAYS<<"";

	} while (!testCancel() && !_done);	// repeat as long it is canceld or set as Done
}

void ThreadedWorker::setDone(bool done)
{
	_done = done;
}

int ThreadedWorker::cancel()
{
    OSG_ALWAYS<<"Cancelling ThreadedWorker "<<this<<" isRunning()="<<isRunning()<<std::endl;

    if( isRunning() )
    {
        _done = true;

        OSG_ALWAYS<<"   Doing cancel "<<this<<std::endl;

        // then wait for the the thread to stop running.
        while(isRunning())
        {
            // commenting out debug info as it was cashing crash on exit, presumable
            // due to OSG_NOTIFY or std::cout destructing earlier than this destructor.
            //OSG_ALWAYS<<"   Waiting for ThreadedWorker to cancel "<<this<<std::endl;
            OpenThreads::Thread::YieldCurrentThread();
        }
    }

    OSG_ALWAYS<<"  ThreadedWorker::cancel() thread cancelled "<<this<<" isRunning()="<<isRunning()<<std::endl;

    return 0;
}